/* evalWriteFile2.c */

/****************************************************************************

The file "data" contains the exam results for 10 students.
Each student done 4 subjects.

The following program was written to perform the following steps:
1- read the content of the file "record.doc" into a 2-D array.
2- sort the list by student ID numbers.
3- find the average mark for each student.
4- display on the screen the sorted list, along with an extra column
   for the average student marks.

*****************************************************************************/
#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#define SUBJECT 10
#define LINE 4
#define COL 10

void  readin();
float  average(int);
void write();

int   ID[LINE], marks[LINE][COL];
  float av_std[]={0,0,0,0,0,0,0,0,0,0};  



/******************************************************************************
***************** FUNCTION NAME   : main() *****************************

This is the main  program ..  It calls 3 functions.

*******************************************************************************/
main(){

  int   y;
/*  float av_std[]={0,0,0,0,0,0,0,0,0,0};   */
/*  float av_std[]={0.0};  does not work!  */


  readin();

  for(y=0 ; y< COL ; y++)
    {
      av_std[y] = average(y);
    }
 write();
  
}



/******************************************************************************
***************** FUNCTION NAME   : average() *****************************a

This function will calculate for each student the average mark from
4 subjects.

a*****************************************************************************a*/
float average(int Z)
{
  int i;
  float temp=0.0;
/*       temp = marks[Z][0]+marks[Z][1]+marks[Z][2]+marks[Z][3];  */
   for (i=0; i <LINE ; i++)
     {
     temp += marks[i][Z];
     }
  
    temp = temp/LINE;
      return(temp);
}





/***********************************************************************
 ***********************FUNCTION: readin() *****************************a
This function read the file line-by-line.
For each line, the ID and four marks are detected and stored into arrays. 
a*************************************************************************/
void readin() 
{
  char  line[100];
  char  *word1,*word2,*word3,*word4,*word5,*word6, *word7, *word8,*word9,*word10, *word11;
  int   count=0,x=0;
  float num;
  FILE  *fp;

  fp = fopen("data","r");

  while(fgets(line,100,fp) != NULL)
    {
      if(count > 1)
	{
	  word1 = strtok(line,"\t ");
	  word2 = strtok(NULL,"\t \n");
	  word3 = strtok(NULL,"\t \n");
	  word4 = strtok(NULL,"\t \n");
	  word5 = strtok(NULL,"\t \n");
	  word6 = strtok(NULL,"\t \n");
	  word7 = strtok(NULL,"\t \n");
	  word8 = strtok(NULL,"\t \n");
	  word9 = strtok(NULL,"\t \n");
	  word10 = strtok(NULL,"\t \n");
	  word11 = strtok(NULL,"\t \n");
	  
	  ID[x] = atoi(word1);
	  marks[x][0] = atoi(word2);
	  marks[x][1] = atoi(word3);
	  marks[x][2] = atoi(word4);
	  marks[x][3] = atoi(word5);
	  marks[x][4] = atoi(word6);
	  marks[x][5] = atoi(word7);
	  marks[x][6] = atoi(word8);
	  marks[x][7] = atoi(word9);
	  marks[x][8] = atoi(word10);
	  marks[x][9] = atoi(word11);

	  x++;
	}
      count++;
    }
}


void write()
{
  int x;
 
  FILE  *fpOut;
 
   fpOut = fopen("result", "w");

fprintf(fpOut,"-----------------------------------------------------------------------------------\n");
  fprintf(fpOut, "|ID\t|Q1\t|Q2\t|Q3\t|Q4\t|Q5\t|Q6\t|Q7\t|Q8\t|Q9\t|Q10\t\n");

fprintf(fpOut,"------------------------------------------------------------------------------------\n");
  
  for(x=0 ; x<LINE ; x++)
    {
      fprintf(fpOut,"| %d\t",ID[x]);

fprintf(fpOut,"|%d\t|%d\t|%d\t|%d\t|%d\t|%d\t|%d\t|%d\t|%d\t|%d\n" ,marks[x][0],marks[x][1],marks[x][2],marks[x][3],
marks[x][4],marks[x][5], marks[x][6], marks[x][7], marks[x][8], marks[x][9]);
    }
fprintf(fpOut,"\n--------------------------------------- Averages ------------------------------------\n");

fprintf(fpOut, "\t");
  for(x=0 ; x<COL ; x++)
      fprintf(fpOut,"|%.2f\t",av_std[x]);

fprintf(fpOut,"\n-------------------------------------------------------------------------------------\n");



}






